class TEMPS
--  saisis,
--  ok,
--  affiche,
--  efface,
--  fixe_compose,
--  fixe_ennaire,
--  fixe_reliquat,
--  reliquat,
--  valeur, fixe_valeur,
inherit	EXCEPTIONS; ES; SEPARATEUR; CORDEMIN rename make as cordemin_make

creation
	make
	
feature { ANY }
  valeur: INTEGER;
  reliquat: INTEGER;
  ok: BOOLEAN;

feature { NONE }
  valeur_par_temps: INTEGER;
  compose: BOOLEAN;
  ennaire: INTEGER;
  separateur: BOOLEAN;
  
feature 
  fixe_compose is do compose:= true end;

  fixe_ennaire(e: INTEGER) is require e >= 2 and e <= 7 do ennaire:= e end;

  fixe_reliquat(rlq: INTEGER) is do reliquat:= rlq end;

  saisis is
  local sym: expanded SYMBOLE;
        aju_n: expanded AJUSTEUR_NOTE; aju_s: expanded AJUSTEUR_SILENCE;
        som: INTEGER;
        grp_simple: GROUPE_SIMPLE; grp_compose: GROUPE_COMPOSE;
        elt: ELT_RYT;
  do
    ok:= true;
    from som:= reliquat
    -- reliquat peut etre different de 0
    until som >= valeur_par_temps or ok = false
    loop
      es.lis_car;
      inspect es.car
        when '(' then
          es.ecr_car('(');
          if compose
          then
            !! grp_compose.make;
            grp_compose.saisis;
            if grp_compose.ok
            then
              insere_d(grp_compose);
              som:= som+grp_compose.valeur;
              valeur:= valeur+grp_compose.valeur;
              es.lis_car;
              if es.car = '_' then es.ecr_car('_'); grp_compose.lie
              else es.remet_car end
            else grp_compose.efface;
					   -- grp_compose.forget -- parce que n'pas de GC
						grp_compose:= Void
					end
          else
            !! grp_simple.make;
            grp_simple.saisis;
            if grp_simple.ok
            then
              insere_d(grp_simple);
              som:= som+grp_simple.valeur;
              valeur:= valeur+grp_simple.valeur;
              es.lis_car;
              if es.car = '_' then es.ecr_car('_'); grp_simple.lie
              else es.remet_car end
            else grp_simple.efface;
					   -- grp_simple.forget -- parce que n'pas de GC
						grp_simple:= Void
					end
          end 
        when Ch_bs, '%/127/' then -- Ch_del then -- backspace 
          if vide then ok:= false
          else
            elt?= courant;
            som:= som-elt.valeur; valeur:= valeur-elt.valeur;
            elt.efface;
            supprime_g; -- si vide on est sur la tete (fais le forget)
          end
        when '?' then -- provoque un ajustement automatique
          if som < valeur_par_temps then
            aju_n.fixe_valeur_par_temps(valeur_par_temps);
            aju_n.fixe_corde(current);
            if compose then aju_n.fixe_compose end;
            aju_n.fixe_ennaire(ennaire);
            aju_n.complete(valeur_par_temps-som);
            valeur:= valeur+(valeur_par_temps-som); -- pas apres (som:= ..)
            som:= valeur_par_temps
          end
        when '%%' then -- provoque un ajustement avec des silences
          if som < valeur_par_temps then
            aju_s.fixe_valeur_par_temps(valeur_par_temps);
            aju_s.fixe_corde(current);
            if compose then aju_s.fixe_compose end;
            aju_s.fixe_ennaire(ennaire);
            aju_s.complete(valeur_par_temps-som);
            valeur:= valeur+(valeur_par_temps-som); -- pas apres (som:= ..)
            som:= valeur_par_temps
          end
        else
          es.remet_car;
          sym.saisis;
          if sym.ok then -- saisie ok ?
            elt:= sym.nouveau;
            insere_d(elt);
            som:= som+elt.valeur; valeur:= valeur+elt.valeur
          else if vide then ok:= false end
          end
      end
    end;
    reliquat:= som-valeur_par_temps;
    if ok then
      if reliquat /= 0 then es.aff_attn(es.temps_attn); es.rafraichis end;
      elt?= courant;
      if not elt.liaison then
        separateur:= true;
        es.lis_car;
        if es.car = blanc 
        then es.ecr_car(blanc) 
        else es.ecr_car(blanc); es.remet_car end
      end
    end
  end;

  fixe_valeur is
  local elt: ELT_RYT;
  do
    from debute; valeur:= 0
    until fini
    loop
      elt?= courant;
      valeur:= valeur+elt.valeur;
      avance
    end
  end;

  affiche is
  local elt: ELT_RYT;
  do
    from debute
    until fini
    loop
      elt?= courant;
      elt.affiche;
      avance;
    end;
    if separateur then es.ecr_car(blanc) end
  end;

  efface is
  local elt: ELT_RYT;
  do
    if not vide then if separateur then es.eff_car end end;
    from termine
    until debut -- et pas debute (devrait s'appeler est_debut, est_vide)
    loop
      elt?= courant;
      elt.efface;
      supprime_g; -- recule est fait par supprime_gauche (precedent -> courant)
    end
  end;

  make(vt: INTEGER) is
  do
    cordemin_make;
    valeur_par_temps:= vt; compose:= false; reliquat:= 0; separateur:= false
  end;

end -- class TEMPS
